void AfficheJeu(HDC hdc)
{
	// Rcuprer la taille de la surface de dessin
	int w = 740;
	int h = 700;

	// Dessinons sur un bitmap pour eviter les tremblements
	HDC hMemDC = CreateCompatibleDC (hdc);
	HBITMAP hBitmap = CreateCompatibleBitmap (hdc, w, h);
	HBITMAP hOldBitmap = (HBITMAP)SelectObject (hMemDC, hBitmap) ;
	//creation de la police
	HFONT police;
	HPEN pen;
	HBRUSH brush;
    HGDIOBJ Police,Pen,Brush;
	police=CreateFont(30,0,0,0,700,FALSE,FALSE,FALSE,0,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH | FF_DONTCARE, "Nonstop");
	Police=SelectObject(hMemDC,police);
	//afficher l'image de fond
	DrawState(hMemDC,NULL,NULL,(LPARAM)hFond,NULL,0,0,740,560,DST_BITMAP); 

	//afficher le rectangle o sont marqus le score,etc..
	SetTextColor(hMemDC,RGB(0,180,0));
	SetBkMode(hMemDC, TRANSPARENT);
	pen = CreatePen(PS_SOLID, 3,RGB(192,192,192));
	Pen = SelectObject(hMemDC,pen);
	brush = CreateSolidBrush(RGB(0,0,0));
	Brush = SelectObject(hMemDC,brush);

	Rectangle(hMemDC,-3,545,740,700);

	SelectObject(hMemDC,Pen);          
	DeleteObject(pen);
	SelectObject(hMemDC,Brush);          
	DeleteObject(brush);

	//afficher le texte
	sprintf(buf,"Vitesse:%d ",vitesseS);
	TextOut(hMemDC,20,550,buf,strlen(buf));
	sprintf(buf,"Score:%d ",score);
	TextOut(hMemDC,265,550,buf,strlen(buf));
	sprintf(buf,"Mange:%d ",Amange);
	TextOut(hMemDC,520,550,buf,strlen(buf));

	//afficher le serpent
	for (var=0;var<=longeureS;var++)
		DrawState(hMemDC,NULL,NULL,(LPARAM)Isnake[snake[var].icone],NULL,snake[var].x*32,snake[var].y*32,32,32,DST_ICON);
	
	//afficher les Objets
	for (var=1;var<=10;var++)
	{
		int var2;
		switch (Objets[var].type)
		{
		case O_OEUF:var2=20;break;
		case O_NIVPLUS:var2=19;break;
		case O_SOURIS:var2=20+Objets[var].pos;break;
		case O_NIVMOINS:var2=25;break;
		case O_LONGPLUS:var2=26;break;
		case O_COEUR:var2=27;break;
		}
		if (Objets[var].type!=0) DrawState(hMemDC,NULL,NULL,(LPARAM)Isnake[var2],NULL,Objets[var].x*32,Objets[var].y*32,32,32,DST_ICON);
	}
	if (debut)
	{
		//detruirela vielle police
		SelectObject(hMemDC,Police);          
		DeleteObject(police);
		//creer la nouvelle
		police=CreateFont(180,0,0,0,700,FALSE,FALSE,FALSE,0,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH | FF_DONTCARE, AgentOrange);
		Police=SelectObject(hMemDC,police);
		//on definit buf
		sprintf(buf,"%d...",debut-1);
		if (debut==1) sprintf(buf,"GO !");
		var=300;
		if (debut==1) var=240;
		//on affiche l'ombre grise
		SetTextColor(hMemDC,RGB(255,255,255));
		TextOut(hMemDC,var+3,183,buf,strlen(buf));
		//on affiche le texte noir
		SetTextColor(hMemDC,RGB(0,0,0));
		TextOut(hMemDC,var,180,buf,strlen(buf));

	}
	if (gameover)
	{
		//detruire la vielle police
		SelectObject(hMemDC,Police);          
		DeleteObject(police);
		//creer la nouvelle
		police=CreateFont(130,0,35,0,700,FALSE,FALSE,FALSE,0,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH | FF_DONTCARE, AgentOrange);
		Police=SelectObject(hMemDC,police);
		//on definit buf
		sprintf(buf,"Game Over !");
		//on affiche l'ombre grise
		SetTextColor(hMemDC,RGB(255,255,255));
		TextOut(hMemDC,13,213,buf,strlen(buf));
		//on affiche le texte noir
		SetTextColor(hMemDC,RGB(0,0,0));
		TextOut(hMemDC,10,210,buf,strlen(buf));

	}
	if (pause)
	{
		//detruire la vielle police
		SelectObject(hMemDC,Police);          
		DeleteObject(police);
		//creer la nouvelle
		police=CreateFont(130,0,35,0,700,FALSE,FALSE,FALSE,0,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH | FF_DONTCARE, AgentOrange);
		Police=SelectObject(hMemDC,police);
		//on definit buf
		sprintf(buf,"     PAUSE ! ");
		//on affiche l'ombre grise
		SetTextColor(hMemDC,RGB(255,255,255));
		TextOut(hMemDC,13,213,buf,strlen(buf));
		//on affiche le texte noir
		SetTextColor(hMemDC,RGB(0,0,0));
		TextOut(hMemDC,10,210,buf,strlen(buf));


	}
	if (AnimGameOver)
	{
		pen = CreatePen(PS_SOLID, 3,RGB(0,0,0));
		Pen = SelectObject(hMemDC,pen);
		brush = CreateSolidBrush(RGB(0,0,0));
		Brush = SelectObject(hMemDC,brush);

		Rectangle(hMemDC,0,0,AnimGameOver,625);
		Rectangle(hMemDC,0,0,740,AnimGameOver);
		Rectangle(hMemDC,0,625-AnimGameOver,740,625);
		Rectangle(hMemDC,740-AnimGameOver,0,740,625);

		SelectObject(hMemDC,Pen);          
		DeleteObject(pen);
		SelectObject(hMemDC,Brush);          
		DeleteObject(brush);
		if (AnimGameOver>=320)
		{
			//suprimer la police
			SelectObject(hMemDC,Police);          
			DeleteObject(police);
			//creer la nouvelle police
			police=CreateFont(40,0,0,0,700,FALSE,FALSE,FALSE,0,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH | FF_DONTCARE, NonStop);
			Police=SelectObject(hMemDC,police);
			//mettre la bonne couleur
			SetTextColor(hMemDC,RGB(0,180,0));
			SetBkMode(hMemDC, TRANSPARENT);
			//afficher le texte
			sprintf(buf,"Votre score: %d",score);
			TextOut(hMemDC,50,50,buf,strlen(buf));
			sprintf(buf,"Meilleur score: %d",HighScore);
			TextOut(hMemDC,50,220,buf,strlen(buf));
			//detruire la police
			SelectObject(hMemDC,Police);          
			DeleteObject(police);
			//creer la nouvelle police
			police=CreateFont(26,0,0,0,700,FALSE,FALSE,FALSE,0,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH | FF_DONTCARE, NonStop);
			Police=SelectObject(hMemDC,police);
			sprintf(buf,"Par: %s",HighName);
			TextOut(hMemDC,50,280,buf,strlen(buf));
			//afficher mes coordones
			sprintf(buf,"Envoyez vos scores par mail: ");
			TextOut(hMemDC,20,520,buf,strlen(buf));
			sprintf(buf,"poupoudoum.games@free.fr ");
			TextOut(hMemDC,25,550,buf,strlen(buf));
			//si on a le meilleur score:
			if (score>HighScore)
			{
				SON("highscore");
				HighScore=score;
				DialogBox(NULL,(LPCTSTR)IDD_DIALOG1,hJeu,(DLGPROC)ScoProc);
				EcrireScore();
			}
		}
	}
	// Copier le bitmap sur l'cran
	BitBlt (hdc, 0, 0, w, h, hMemDC, 0, 0, SRCCOPY) ;

	//suprimer la police
	SelectObject(hMemDC,Police);          
	DeleteObject(police);

	// Supprimer le bitmap
	SelectObject (hMemDC, hOldBitmap) ;
	DeleteObject (hBitmap) ;
	DeleteDC (hMemDC) ;
}

void NouvJeu()
{
	//debut et gameover
	debut=4;
	gameover=0;
	AnimGameOver=0;
	pause=0;
	//son ou pas?
	sons = Boutons[B_SONS].checked;
	ISmusique = Boutons[B_MUSIQUE].checked;
	//position par defaut
	x=12;
	y=8;
	dir=1;
	lastdir=1;
	//on rempit le serpent de barres horizontales et on met Faitgrossir a 0
	for (var=1;var<160;var++)
	{
		snake[var].FaitGrossir=0;
		snake[var].icone=5;
	}
	//on met les scores a 0:
	score=0;
	Amange=0;
	//on definit le positions
	for (var=0;var<=longeureS;var++)
	{
		snake[var].x=x-var;
		snake[var].y=y;
	}
	//on met la tete
	snake[0].icone=1;
	//la queue
	snake[longeureS].icone=13;
	//on regle la vitesse du timer
	switch(vitesseS)
	{
	case 1:	Speed=450;break;
	case 2:	Speed=325;break;
	case 3:	Speed=250;break;
	case 4:	Speed=200;break;
	case 5:	Speed=150;break;
	case 6:	Speed=100;break;
	case 7:	Speed= 75;break;
	case 8:	Speed= 50;break;
	case 9:	Speed= 35;break;
	case 10:Speed= 25;break;
	}
	timesouris=2*vitesseS;
	//on charge l'image de fond
	if (Boutons[B_FORET].checked==1)
		hFond=Foret;
	else if (Boutons[B_HERBE].checked==1)
		hFond=Herbe;
	else if (Boutons[B_CIEL].checked==1)
		hFond=Ciel;
	else hFond=Snake3000;
	//on defini le objets
	Objets[1].type=O_OEUF;
	Objets[2].type=O_OEUF;
	Objets[3].type=O_SOURIS;
	Objets[4].type=O_SOURIS;
	Objets[5].type=O_SOURIS;
	Objets[6].type=O_NIVPLUS;
	Objets[7].type=O_NIVMOINS;
	Objets[8].type=O_LONGPLUS;
	Objets[9].type=0;		//COEUR non present au debut;
	for(var=1;var<=10;var++)
	{
		Objets[var].pos=2;
		do
		{
			varx=(rand()%21);
			vary=(rand()%17);
		}
		while (IsSomething(varx,vary)); 
		Objets[var].x=varx;
		Objets[var].y=vary;
	}
	if (vitesseS==1) Objets[7].type=0;
	if (vitesseS==10)Objets[6].type=0;

}
void TraiterTimer()
{
	if (debut==0 && !AnimGameOver)
	{
		//on place peut etre un coeur?(1 chance sur 200 ... )
		var=(rand()%200);
		if (var==1) PlacerCoeur();
		//on suprime peut etre un coeur?
		Objets[9].pos--;
		if (Objets[9].pos<=0 && Objets[9].type!=0) Objets[9].type=0;
		//on decremente le temps avant que les souris se deplacent
		timesouris--;
		//variable du vecteur de deplacement
		int cx,cy;
		//on verifie su on augmente la longeure du serpent
		if (snake[longeureS-1].icone==8 || snake[longeureS-1].icone==9) 
		{
			snake[longeureS-1].icone=snake[longeureS-1].icone-3;//on remet une icone normale sinon ca grandit tout le temps
			longeureS++;
			if (longeureS>=155) longeureS=155;
		}
		if (snake[longeureS].FaitGrossir>=1) 
		{
			snake[longeureS].FaitGrossir--;
			longeureS++;
			if (longeureS>=155) longeureS=155;
		}
		//on decale tout les blocs du serpent
		for(var=longeureS;var>=1;var--)
		{
			snake[var]=snake[var-1];
		}
		//on definit le vecteur pour avancer
		switch(dir)
		{
		case 1:cx=1;cy=0;break;
		case 3:cx=-1;cy=0;break;
		case 2:cx=0;cy=1;break;
		case 4:cx=0;cy=-1;break;
		}
		//si la direction n'a pas cange: on met une barre droite
		if (dir==lastdir) 
		{
			switch(dir)
			{
			case 1:snake[1].icone=5;break;
			case 3:snake[1].icone=5;break;
			case 2:snake[1].icone=6;break;
			case 4:snake[1].icone=6;break;
			}
			//si le serpent a mang: on mat la bonne icone
			if (mange) snake[1].icone=snake[1].icone+3;
		}
		//sinon on met le bon angle
		else switch(lastdir*10+dir)
		{
		case 12:snake[1].icone=16;break;
		case 14:snake[1].icone=17;break;
		case 21:snake[1].icone=18;break;
		case 23:snake[1].icone=17;break;
		case 32:snake[1].icone=15;break;
		case 34:snake[1].icone=18;break;
		case 41:snake[1].icone=15;break;
		case 43:snake[1].icone=16;break;
		}
		mange=0;
		//on avance la tete
		x=x+cx;
		y=y+cy;
		//on verifie que l'on ne se mange pas soi mme (ca arrive)
		if ((var=IsSomething(x,y))==O_SNAKE) {KillTimer(hJeu,NULL); gameover=1; AnimGameOver=2; SON("Perdu"); ChangerMusique("NO_MUSIC"); SetTimer(hJeu,NULL,3000,NULL);}
		snake[0].x=x;
		snake[0].y=y;
		snake[0].icone=dir;
		//on met la bonne queue:
		cx=snake[longeureS-1].x-snake[longeureS].x;
		cy=snake[longeureS-1].y-snake[longeureS].y;
		switch(cy*10+cx)
		{
		case 1:snake[longeureS].icone=13;break;
		case -1:snake[longeureS].icone=11;break;
		case 10:snake[longeureS].icone=14;break;
		case -10:snake[longeureS].icone=12;break;
		}
		//on met l'anciene direction a jour
		lastdir=dir;
		//on fait traverser les murs
		var=0;
		if(x>22) { x=0; var=1;}
		if (x<0) {x=22; var=1;}
		if(y>16) {y=0;  var=1;}
		if (y<0) {y=16; var=1;}
		if (var) if ((IsSomething(x,y))==O_SNAKE) {KillTimer(hJeu,NULL); AnimGameOver=1; gameover=2; SON("Perdu"); ChangerMusique("NO_MUSIC"); SetTimer(hJeu,NULL,3000,NULL);}
		snake[0].x=x;
		snake[0].y=y;
		//on verifie si on boufe 
		VerifMange();
		//si timesouris=0 on deplace les souris
		if (!timesouris) DeplaceSouris();
	}
	//si animation en cours
	else if(AnimGameOver!=0 && AnimGameOver<320)
	{
		AnimGameOver+=2;
		if (AnimGameOver<=6) 
		{
			KillTimer(hJeu,NULL);
			SetTimer(hJeu,NULL,10,NULL);
		}
		GetClientRect(hJeu,&rcclient);
		RedrawWindow(hJeu,&rcclient,NULL,RDW_INVALIDATE|RDW_NOCHILDREN);
			
	}
	else	//sinon
	{
		debut--;
		if (debut==0) 
		{
			KillTimer(hJeu,NULL);
			SetTimer(hJeu,NULL,Speed,NULL);
		}
	}
}
void GestionTouches(int key)
{
	switch (key)
	{
	case VK_LEFT:if (dir!=1) dir=3;break;
	case VK_UP:if (dir!=2) dir=4;break;
	case VK_DOWN:if (dir!=4) dir=2;break;
	case VK_RIGHT:if (dir!=3) dir=1;break;
	}
}
void VerifMange()
{
	for(var=1;var<=10;var++)
	{
		if (Objets[var].x==x && Objets[var].y==y && Objets[var].type!=0) Mange(Objets[var].type,var);
	}
}

void Mange(int type,int numero)
{
	switch(type)
	{
	case O_NIVPLUS:
		{
			score=score+10;
			SON("Vitesse+");
			vitesseS++;
			KillTimer(hJeu,NULL);
			//on regle la vitesse du timer
			switch(vitesseS)
			{
			case 1:	Speed=450;break;
			case 2:	Speed=325;break;
			case 3:	Speed=250;break;
			case 4:	Speed=200;break;
			case 5:	Speed=150;break;
			case 6:	Speed=100;break;
			case 7:	Speed= 75;break;
			case 8:	Speed= 50;break;
			case 9:	Speed= 35;break;
			case 10:Speed= 25;break;
			}
			timesouris=2*vitesseS;
			SetTimer(hJeu,NULL,Speed,NULL);
			if (vitesseS<10)//si la vitesse n'est pas maxi: replacer un objet
			{
				do
				{
					varx=(rand()%21);
					vary=(rand()%17);
				}while (IsSomething(varx,vary));
				Objets[6].x=varx;
				Objets[6].y=vary;
			}
			if (vitesseS>=10)
			{
				Objets[6].type=0;
			};
			//si le bonus de vitesse moins n'existe pas: recreer un bonus de vitesse moins
			if (Objets[7].type==0) 
			{
				do
				{
					varx=(rand()%21);
					vary=(rand()%17);
				}while (IsSomething(varx,vary));
				Objets[7].x=varx;
				Objets[7].y=vary;
				Objets[7].type=O_NIVMOINS;
			}
			break;
		}
	case O_NIVMOINS:
		{
			score=score+10;
			SON("Vitesse-");
			vitesseS--;
			KillTimer(hJeu,NULL);
			//on regle la vitesse du timer
			switch(vitesseS)
			{
			case 1:	Speed=450;break;
			case 2:	Speed=325;break;
			case 3:	Speed=250;break;
			case 4:	Speed=200;break;
			case 5:	Speed=150;break;
			case 6:	Speed=100;break;
			case 7:	Speed= 75;break;
			case 8:	Speed= 50;break;
			case 9:	Speed= 35;break;
			case 10:Speed= 25;break;
			}
			timesouris=2*vitesseS;
			SetTimer(hJeu,NULL,Speed,NULL);
			if (vitesseS>1)//si la vitesse n'est pas mini: replacer un objet
			{
				do
				{
					varx=(rand()%21);
					vary=(rand()%17);
				}while (IsSomething(varx,vary));
				Objets[7].x=varx;
				Objets[7].y=vary;
			}
			if (vitesseS<=1)
			{
				Objets[7].type=0;
			};
			//si le bonus de vitesse plus n'existe pas: recreer un bonus de vitesse moins
			if (Objets[6].type==0) 
			{
				do
				{
					varx=(rand()%21);
					vary=(rand()%17);
				}while (IsSomething(varx,vary));
				Objets[6].x=varx;
				Objets[6].y=vary;
				Objets[6].type=O_NIVPLUS; 
			}
			break;
		}
	case O_LONGPLUS:
		{
			SON("ralonge");
			score += longeureS/2;
			snake[longeureS-1].FaitGrossir=5;
			do
			{
				varx=(rand()%21);
				vary=(rand()%17);
			}while (IsSomething(varx,vary));
			Objets[8].x=varx;
			Objets[8].y=vary;
			if (longeureS>=155) Objets[8].type=0;
			break;
		}
	case O_COEUR:
		{
			SON("magie");
			Objets[9].type=0;
			longeureS=2;
			break;
		}
	default:
		{//si ce n'est pas un bonus de vitesse
			Amange++;
			mange=1;
			if (type==O_OEUF) SON("slurp");
			else SON("crounch");
			score=score+(type*((longeureS/2)+vitesseS));
			do
			{
				varx=(rand()%21);
				vary=(rand()%17);
			}while (IsSomething(varx,vary));
			Objets[numero].x=varx;
			Objets[numero].y=vary;
			break;
		}
	}
}
int IsSomething(int X,int Y)
{
	if(X>22 || X<0 || Y<0 ||Y>16 ) return 5;
	int retour=0;
	int var3;
	for(var3=0;var3<=longeureS;var3++)
	{
		if (snake[var3].x==X && snake[var3].y==Y) retour=O_SNAKE;
	}
	for(var3=1;var3<=10;var3++)
	{
		if (Objets[var3].x==X && Objets[var3].y==Y) retour=Objets[var3].type;
	}
	return retour;
}
void DeplaceSouris()
{
	timesouris=2*vitesseS;
	int cx,cy;//comme pour le serpent
	for(int varS=3;varS<=5;varS++)
	{
		switch(Objets[varS].pos)
		{
			case 1:cx=1;cy=0;break;
			case 3:cx=-1;cy=0;break;
			case 2:cx=0;cy=1;break;
			case 4:cx=0;cy=-1;break;
		}
		var=IsSomething(Objets[varS].x+cx,Objets[varS].y+cy);
		if (!var)
		{
			Objets[varS].x+=cx;
			Objets[varS].y+=cy;
		}
		Objets[varS].pos=1+(rand()%4);
	}
}
void PlacerCoeur()
{
	if (Objets[9].type==0)
	{
		do
		{
			varx=(rand()%21);
			vary=(rand()%17);
		}while (IsSomething(varx,vary));
		Objets[9].x=varx;
		Objets[9].y=vary;
		Objets[9].pos=vitesseS*(1+(rand()%5));
		Objets[9].type=O_COEUR;
	}
}
