// ce fichier contient toutes les fontion de gestion du menu
void PeindreMenu (HDC hdc)	//fonction d' affichege du menu
{
	// Rcuprer la taille de la surface de dessin
	int w = 550;
	int h = 600;

	// Dessinons sur un bitmap pour eviter les tremblements
	HDC hMemDC = CreateCompatibleDC (hdc);
	HBITMAP hBitmap = CreateCompatibleBitmap (hdc, w, h);
	HBITMAP hOldBitmap = (HBITMAP)SelectObject (hMemDC, hBitmap) ;
	//creation de la police
	HFONT police;
    HGDIOBJ Police;
	police=CreateFont(19,0,0,0,700,FALSE,FALSE,FALSE,0,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH | FF_DONTCARE, "Arial Rounded MT Bold");
	Police=SelectObject(hMemDC,police);
	SetBkMode(hMemDC, TRANSPARENT);

	//afficher l'image de fond
	DrawState(hMemDC,NULL,NULL,(LPARAM)hFondMenu,NULL,0,0,550,600,DST_BITMAP); 

	// les textes "Vitesse" et "Longueure"
	TextOut(hMemDC,115,420,"Vitesse     ",10);
	TextOut(hMemDC,100,480,"Longueure       ",13);
	
	// les progress bar
	PROGRESS(hMemDC,45,450,200,vitesseS*20,Cvert);
	PROGRESS(hMemDC,45,510,200,longeureS*10,Cvert);


	//afficher le boutons
	for (var=1;var<=11;var++)
	{
		//affiche l'icone des boutons
		if (Boutons[var].selec==0)DrawState(hMemDC,NULL,NULL,(LPARAM)Boutons[var].icone,NULL,Boutons[var].x,Boutons[var].y,Boutons[var].cx,Boutons[var].cy,DST_ICON);
		else DrawState(hMemDC,NULL,NULL,(LPARAM)Boutons[var].iconeselec,NULL,Boutons[var].x,Boutons[var].y,Boutons[var].cx,Boutons[var].cy,DST_ICON);
		//afficher le texte
		TextOut(hMemDC,Boutons[var].x+Boutons[var].xtxt,Boutons[var].y+Boutons[var].ytxt,Boutons[var].text,strlen(Boutons[var].text));
		//aficher l'icone 'souris' si le boutons est selection
		if (Boutons[var].checked)DrawState(hMemDC,NULL,NULL,(LPARAM)checked,NULL,Boutons[var].x+131,Boutons[var].y,32,32,DST_ICON);
	}

	// Copier le bitmap sur l'cran
	BitBlt (hdc, 0, 0, w, h, hMemDC, 0, 0, SRCCOPY) ;

	//suprimer la police
	SelectObject(hMemDC,Police);          
	DeleteObject(police);

	// Supprimer le bitmap
	SelectObject (hMemDC, hOldBitmap) ;
	DeleteObject (hBitmap) ;
	DeleteDC (hMemDC) ;
}

int SourisSelec(POINT pos)
{
	for (var=1;var<=11;var++) Boutons[var].selec=0;
	int btn=0;
	for (var=1;var<=11;var++)
	{
		if (pos.x>=Boutons[var].x && pos.x<=Boutons[var].x+Boutons[var].cx && pos.y>=Boutons[var].y && pos.y<=Boutons[var].y+Boutons[var].cy)
			btn=var;
	}
	Boutons[btn].selec=1;
	return btn;	
}

void ActionBouton(int btn)
{
	switch (btn)
	{
	case B_MUSIQUE: Boutons[B_MUSIQUE].checked=!Boutons[B_MUSIQUE].checked;break;
	case B_SONS: Boutons[B_SONS].checked=!Boutons[B_SONS].checked;break;
	sons = Boutons[B_SONS].checked;
	ISmusique = Boutons[B_MUSIQUE].checked;
	
	switch (ISmusique)
	{
	case 1:ChangerMusique("musiquemenu");break;
	case 0:ChangerMusique("NO_MUSIC");break;
	}
	case B_FORET:
		{
			Boutons[B_HERBE].checked=0;
			Boutons[B_CIEL].checked=0;
			Boutons[B_SNAKE3000].checked=0;
			Boutons[B_FORET].checked=1;
			break;
		}
	case B_HERBE:
		{
			Boutons[B_FORET].checked=0;
			Boutons[B_CIEL].checked=0;
			Boutons[B_SNAKE3000].checked=0;
			Boutons[B_HERBE].checked=1;
			break;
		}
	case B_CIEL:
		{
			Boutons[B_HERBE].checked=0;
			Boutons[B_SNAKE3000].checked=0;
			Boutons[B_CIEL].checked=1;
			Boutons[B_FORET].checked=0;
			break;
		}
	case B_SNAKE3000:
		{
			Boutons[B_HERBE].checked=0;
			Boutons[B_SNAKE3000].checked=1;
			Boutons[B_CIEL].checked=0;
			Boutons[B_FORET].checked=0;
			break;
		}
	case B_VITESSE_P:vitesseS++; if (vitesseS>10) vitesseS=10; break;
	case B_VITESSE_M:vitesseS--; if (vitesseS<1) vitesseS=1; break;
	case B_LONG_P:longeureS++; if (longeureS>20) longeureS=20; break;
	case B_LONG_M:longeureS--; if (longeureS<2) longeureS=2; break;
	
	}
	
	sons = Boutons[B_SONS].checked;
	ISmusique = Boutons[B_MUSIQUE].checked;
	
	switch (ISmusique)
	{
	case 1:ChangerMusique("musiquemenu");break;
	case 0:ChangerMusique("NO_MUSIC");break;
	}
}